/// This file is inspired from gesture_x_detector.dart from the [gesture_x_detector](https://github.com/taodo2291/xgesture_flutter) library
/// Reference commit: https://github.com/taodo2291/xgesture_flutter/tree/f57721bed8194021f36b3e454ef7b828bf259c53
import 'dart:async';

import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/widgets.dart';


class a117 {
  
  final Offset a100;

  
  final Offset a99;

  
  final Offset a98;

  
  a117._a193(_a120 a501)
      : a100 = a501.a84,
        a99 = a501.a83 - a501.a84,
        a98 =
            a501.a82.getVelocityEstimate()?.pixelsPerSecond ??
                Offset.zero;
}

/// Signature for listening to tap events.
typedef TapEventListener = void Function(PointerEvent event);

/// Signature for listening to move events.
typedef MoveEventListener = void Function(a117 event);


class a118 extends StatefulWidget {
  
  const a118({
    Key? a502,
    required this.a97,
    this.a96,
    this.a95,
    this.a94,
    this.a93,
    this.a92,
    this.a91,
    this.a89 = kLongPressTimeout,
    this.a90 = kTouchSlop,
  }) : super(key: a502);

  
  final Widget a97;

  
  final TapEventListener? a96;

  
  final TapEventListener? a95;

  
  final Function()? a94;

  
  final MoveEventListener? a93;

  
  final MoveEventListener? a92;

  
  final MoveEventListener? a91;

  
  final double a90;

  
  final Duration a89;

  @override
  _a122 createState() => _a122();
}

enum _a119 {
  a88,
  a87,
  a86,
  a85,
}

@immutable
class _a120 {
  final Offset a84;
  final Offset a83;
  final VelocityTracker a82;

  Offset get a6 => a83 - a84;

  factory _a120.a194(PointerEvent a503) {
    return _a120._a195(
      a83: a503.localPosition,
      a84: a503.localPosition,
      a82: VelocityTracker.withKind(a503.kind)
        ..addPosition(a503.timeStamp, a503.position),
    );
  }

  const _a120._a195({
    required this.a83,
    required this.a84,
    required this.a82,
  });

  _a120 a26({
    Offset? a481,
    Offset? a482,
    VelocityTracker? a483,
  }) {
    return _a120._a195(
      a83: a482 ?? this.a83,
      a84: a481 ?? this.a84,
      a82: a483 ?? this.a82,
    );
  }
}

@immutable
class _a121 {
  final IMap<int, _a120> a81;
  final _a119 a80;

  const _a121({required this.a81, required this.a80});

  _a121 a25({
    IMap<int, _a120>? a479,
    _a119? a480,
  }) {
    return _a121(
      a81: a479 ?? this.a81,
      a80: a480 ?? this.a80,
    );
  }
}

class _a122 extends State<a118> {
  var _a309 = _a121(
    a81: IMap<int, _a120>(),
    a80: _a119.a85,
  );

  Timer? a79;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      child: widget.a97,
      onPointerDown: _a196,
      onPointerUp: _a199,
      onPointerMove: _a197,
      onPointerCancel: _a200,
    );
  }

  @override
  void dispose() {
    _a204();
    super.dispose();
  }

  void _a196(PointerDownEvent a504) {
    final a310 = _a120.a194(a504);

    _a309 = _a309.a25(
      a479: _a309.a81.add(a504.pointer, a310),
    );

    if (_a211 == 1) {
      _a309 = _a309.a25(a480: _a119.a88);
      _a202(a504);
    } else {
      _a309 = _a309.a25(a480: _a119.a85);
    }
  }

  void _a197(PointerMoveEvent a505) {
    final a311 = _a309.a81[a505.pointer];

    if (a311 == null) return;

    final a312 = a311.a26(a482: a505.localPosition);

    if (!_a203(a312)) {
      _a204();
    }

    final a313 = () {
      switch (_a309.a80) {
        case _a119.a86:
          return a312.a26(
            a481: a312.a83,
          );

        case _a119.a88:
          return _a198(a312, a505);

        case _a119.a87:
          a312.a82.addPosition(
            a505.timeStamp,
            a505.position,
          );

          _a209(a312);

          return a312;

        default:
          return a312.a26(
            a481: a312.a83,
          );
      }
    }();

    _a309 = _a309.a25(
      a479: _a309.a81.add(a505.pointer, a313),
    );
  }

  _a120 _a198(_a120 a506, PointerMoveEvent a507) {
    final a314 = a506.a26(a482: a507.localPosition);

    if (!_a203(a314)) {
      _a309 = _a309.a25(a480: _a119.a87);
      _a208(a314);
    }

    return a314;
  }

  void _a199(PointerUpEvent a508) {
    final a315 = _a309.a81[a508.pointer];
    if (a315 == null) return;

    final a316 = a315.a26(a482: a508.position);

    _a309 = _a309.a25(
      a479: _a309.a81.add(a508.pointer, a316),
    );

    switch (_a309.a80) {
      case _a119.a88:
        _a205(a508.copyWith(position: a316.a84));
        break;

      case _a119.a87:
        a316.a82.addPosition(
          a508.timeStamp,
          a508.position,
        );

        _a210(a316);
        break;

      case _a119.a86:
        _a207();
        break;

      case _a119.a85:
        break;
    }

    _a309 = _a309.a25(a480: _a119.a85);

    _a201(a508.pointer);
  }

  void _a200(PointerCancelEvent a509) {
    _a201(a509.pointer);
  }

  void _a201(int a510) {
    _a309 = _a309.a25(
      a479: _a309.a81.remove(a510),
    );
  }

  void _a202(PointerEvent a511) {
    if (widget.a95 != null) {
      a79?.cancel();
      a79 = Timer(widget.a89, () {
        final a317 = _a309.a81[a511.pointer];

        if (_a211 == 1 && a317 != null) {
          _a309 = _a309.a25(a480: _a119.a86);
          _a206(a511);
          _a204();
        }
      });
    }
  }

  bool _a203(_a120 a512) {
    return a512.a6.distance.abs() <= widget.a90;
  }

  void _a204() {
    a79?.cancel();
    a79 = null;
  }

  void _a205(PointerEvent a513) {
    widget.a96?.call(a513);
  }

  void _a206(PointerEvent a514) {
    widget.a95?.call(a514);
  }

  void _a207() {
    widget.a94?.call();
  }

  void _a208(_a120 a515) {
    widget.a93?.call(a117._a193(a515));
  }

  void _a209(_a120 a516) {
    widget.a92?.call(a117._a193(a516));
  }

  void _a210(_a120 a517) {
    widget.a91?.call(a117._a193(a517));
  }

  get _a211 => _a309.a81.length;
}
