import 'package:contentsquare_platform_interface/contentsquare_platform_interface.dart';

import 'contentsquare_gesture_direction_int_serializer.dart';


extension a176 on TouchEventData {
  
  static const _a388 = 'path';
  static const _a389 = 'distance';
  static const _a390 = 'direction';
  static const _a391 = 'velocity';

  
  Map<String, dynamic> a256() {
    return {
      _a388: path,
      _a389: gestureData?.distance,
      _a390: gestureData?.direction.a278(),
      _a391: gestureData?.velocity,
    };
  }

  
  static TouchEventData a257(Map<String, dynamic> a565) {
    final a392 = a565[_a389];
    final a393 = a565[_a390];
    final a394 = a565[_a391];

    final a395 =
        a392 != null && a393 != null && a394 != null;

    /// Return a [TouchEventData] with the given path and gesture data if
    /// provided
    ///
    /// If distance, direction and velocity are provided the gesture is a drag
    /// or a flick.
    /// So, we send the corresponding gesture data.
    /// Otherwise, the gesture is a tap or a long press,
    /// we only need to send the path of the element touched.
    return TouchEventData(
      path: a565[_a388] as String,
      gestureData: a395
          ? ContentsquareGestureData(
              distance: a392 as int,
              direction: a179.a279(
                a393 as int,
              ),
              velocity: a394 as int,
            )
          : null,
    );
  }
}
