import 'dart:collection';
import 'dart:convert';

import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

import '../webview_tracking/webview_tracking.dart';
import 'compression.dart';
import 'element_tree.dart';
import 'render_object_extension.dart';
import 'widgets_binding.dart';


RenderView a240() {
  return a172.a217!.renderView;
}






Future<String> a241({
  required String a542,
  required double a543,
}) async {
  final a360 = _a242();

  final a361 = await a360.a20(
    a473: a543,
    
    a474: null,
    a475: a542,
  );

  
  
  a361[0]['style']['bmp'] =
      'com_contentsquare_rootViewBitmapPlaceholder';

  return json.encode(a361);
}


a133 _a242() {
  final a362 = a240();

  final a363 = a191();

  final a364 = _a246(
    a548: a362,
    a549: a363,
  );

  
  
  return a364!;
}


class a133 {
  
  a133({
    required this.a62,
    required this.a61,
    required this.a60,
    required this.a59,
    required this.a58,
  }) : assert(
          a62.a232 == a61,
          'The global frame of the render object must match the global frame of the node',
        );

  
  final RenderObject a62;

  
  final Rect a61;

  
  final String a60;

  
  final Widget a59;

  
  final UnmodifiableListView<a133> a58;

  
  String get a4 => '${a59.runtimeType}';

  
  Future<UnmodifiableListView<Map<String, dynamic>>> a20({
    required double a473,
    required Rect? a474,
    required String a475,
  }) async {
    assert(
      () {
        final a365 = a62 == a240();

        return (a365 && a474 == null) ||
            (!a365 && a474 != null);
      }(),
      'The parent global frame must be null if and only if this is the root node',
    );

    Future<UnmodifiableListView<Map<String, dynamic>>>
        a243() async {
      return UnmodifiableListView([
        for (final a366 in a58)
          ...await a366.a20(
            a473: a473,
            a474: a61,
            a475: a475,
          )
      ]);
    }

    
    
    
    final a367 = a245(
      a546: a62,
      a547: a474,
    );
    if (!a367) {
      return a243();
    }

    /// A function which executes:
    ///   - [callback] if [renderObject] is associated to a WebView
    ///   - [orElse] otherwise
    T a244<T>(
      T Function(a128 webViewTrackerRenderObject)
          a544, {
      required T Function() a545,
    }) {
      final a368 = this.a62;

      if (a368 is a128) {
        return a544(a368);
      } else {
        return a545();
      }
    }

    return UnmodifiableListView([
      {
        'id': a4,
        'metadata': {
          'class_name': a4,
          
          
          'fullpath': a475 + a188(a60),
        },

        /// "recordingId" should only be mandatory for session replay
        /// On the iOS SDK, the structure is used for both: snapshoting and
        /// session replay features so it ends up mandatory for the screengraph
        /// passed down to the ExternalBridgeInterface.takeSnapshot completion
        /// For this reason, we set temporarily a 'recordingId' value based on
        /// the widget's runtimeType.
        
        'recordingId': a4,
        'style': {
          'height': a61.height * a473,
          'width': a61.width * a473,
          'x': a61.left * a473,
          'y': a61.top * a473,
          'visibility': true,
        },
        
        
        'format': a244((_) => 2, a545: () => 1),
        'children': await a244(
          (webViewTrackerRenderObject) async => [
            await webViewTrackerRenderObject.a71(),
          ],
          a545: () => a243(),
        ),
      },
    ]);
  }
}


bool a245({
  required RenderObject a546,
  required Rect? a547,
}) {
  final a369 = a546.a232 != null &&
      a547 != a546.a232;

  final a370 =
      a546 is a128;

  return a369 || a370;
}


a133? _a246({
  required RenderObject a548,
  required a116 a549,
}) {
  assert(
    a549.a103 == a548,
    '	_getPaintedRenderObjectNode was called with a [ElementNode] in which the '
    'renderObject does not match the given [paintedRenderObject]',
  );

  final a371 = a548.a233;
  final a372 = a548.a232;

  
  
  
  
  
  if (a371 == null || a372 == null) {
    return null;
  }

  final a373 = <a133>[];
  
  
  final a374 = LayerHandle<ContainerLayer>();
  a374.layer = ContainerLayer();

  final a375 = _a134(
    a374.layer!,
    a371,
  );

  
  
  
  a548.paint(a375, Offset.zero);

  
  a374.layer = null;

  
  final a376 = a375.a3;
  for (final a377 in a376) {
    final a378 = _a247(
      a552: a377,
      a553: a549,
    );

    
    
    
    
    
    
    
    
    
    if (a378 != null) {
      final a379 = _a246(
        a548: a377,
        a549: a378,
      );

      if (a379 != null) {
        a373.add(a379);
      }
    }
  }

  
  
  
  
  
  a548.markNeedsPaint();

  return a133(
    a62: a548,
    a61: a372,
    a59: a549.a104,
    a60: a549.a102,
    a58: UnmodifiableListView(a373),
  );
}


class _a134 extends PaintingContext {
  _a134(
    ContainerLayer a550,
    Rect a551, {
    this.a57,
  }) : super(a550, a551);

  
  UnmodifiableListView<RenderObject> get a3 =>
      UnmodifiableListView<RenderObject>(_a380);

  
  final List<RenderObject> _a380 = <RenderObject>[];

  /// This is what is called by a [renderObject] to paint a child.
  @override
  void paintChild(RenderObject child, Offset offset) {
    _a380.add(child);
    a57?.call(child);

    
  }

  
  final void Function(RenderObject child)? a57;

  /// Some render object use [_a134.pushLayer] to paint
  /// their children. This calls [createChildContext] to create a new context on
  /// which the render object will paint its child.
  /// Therefore we need to also return an [_a134] which will
  /// report to this [_a134] the children that tried to be
  /// painted.
  @override
  _a134 createChildContext(
    ContainerLayer childLayer,
    Rect bounds,
  ) {
    return _a134(
      childLayer,
      bounds,
      a57: _a380.add,
    );
  }
}


a116? _a247({
  required RenderObject a552,
  required a116 a553,
}) {
  final a381 = a553;

  
  
  final a382 = List.of([a381]);
  while (a382.isNotEmpty) {
    final a383 = a382.removeAt(0);
    if (a383.a103 == a552) {
      return a383;
    }

    a382.addAll(a383.a101);
  }

  return null;
}
