import 'dart:convert';

import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare/src/obfuscation/keep.dart';
import 'package:flutter/foundation.dart';

import 'adapters/adapters.dart';

/// The type of event that is sent from the webview.
@a288
enum ContentsquareJavascriptEventEnum {
  /// Send a pageView event or any kind of gesture.
  sendEvent,

  /// Send an exception.
  sendException,

  /// Send a message.
  sendMessage,

  /// Opt in.
  optIn,

  /// Opt out.
  optOut,

  /// Send transaction.
  sendTransaction,

  /// Send dynamic var.
  sendDynamicVar,
}


const _a386 =
    'CSJavascriptBridge_FlutterJavascriptChannel_';


@visibleForTesting
class a139 {
  
  a139({
    required this.a50,
    required this.a49,
    required this.a48,
  });

  
  final Contentsquare a50;

  
  final ContentsquareJavascriptEventEnum a49;

  
  String get _a253 =>
      '$_a386${a49.name}';

  
  final String? Function() a48;

  
  ContentsquareJavascriptChannel get a1 {
    return ContentsquareJavascriptChannel(
      name: _a253,
      onMessageReceived: (message) async {
        return _a254(message);
      },
    );
  }

  
  Future<void> _a254(String a563) {
    final a387 = jsonDecode(a563) as Map<String, dynamic>;
    return _a255(a50).a11(a387);
  }

  a158 _a255(Contentsquare a564) {
    switch (a49) {
      case ContentsquareJavascriptEventEnum.sendEvent:
        return a149(
          a44: a564,
          a43: a48,
        );
      case ContentsquareJavascriptEventEnum.sendException:
        return a155(a40: a564);
      case ContentsquareJavascriptEventEnum.sendMessage:
        return a154(a41: a564);
      case ContentsquareJavascriptEventEnum.optIn:
        return a141(a47: a564);
      case ContentsquareJavascriptEventEnum.optOut:
        return a142(a46: a564);
      case ContentsquareJavascriptEventEnum.sendTransaction:
        return a157(a38: a564);
      case ContentsquareJavascriptEventEnum.sendDynamicVar:
        return a156(a39: a564);
    }
  }

  
  String a19({
    required String Function(String channelName, String data)
        a472,
  }) =>
      '''
function (${_a255(a50).a0.map((name) => name).join(', ')}) {
  ${a472(_a253, 'JSON.stringify({${_a255(a50).a0.map((name) => '"$name": $name').join(', ')}})')};
}''';
}
